Index: utils.c
===================================================================
RCS file: /usr/cvsroot/asterisk/utils.c,v
retrieving revision 1.61
diff -u -u -r1.61 utils.c
--- utils.c	20 Jul 2005 00:13:14 -0000	1.61
+++ utils.c	29 Jul 2005 18:55:38 -0000
@@ -728,4 +728,55 @@
                 *((const char **)endptr) = any ? s - 1 : nptr;
         return (acc);
 }
+
+
+
+/*--- url_decode: Decode URL (overwrite the string)  ---*/
+static void url_decode(char *s) 
+{
+	char *o;
+	unsigned int tmp;
+
+	for (o = s; *s; s++, o++) {
+		if (*s == '%' && strlen(s) > 2 && sscanf(s + 1, "%2x", &tmp) == 1) {
+			/* have '%', two chars and correct parsing */
+			*o = tmp;
+			s += 2;	/* Will be incremented once more when we break out */
+		} else /* all other cases, just copy */
+			*o = *s;
+	}
+	*o = '\0';
+}
+
+/*--- url_encode: write encoded version of url into buf up to len bytes---*/
+static int url_encode(char *url, char *buf, size_t len)
+{
+    char *p;
+    int x = 0;
+    const char urlunsafe[] = " \"#%&+:;<=>?@[\\]^`{|}";
+    const char hex[] = "0123456789ABCDEF";
+
+    memset(buf, 0, len);
+    for( p = url ; *p ; p++) {
+        if (*p < ' ' || *p > '~' || strchr(urlunsafe, *p)) {
+			if ((x + 3) > len) {
+				break;
+			}
+            buf[x++] = '%';
+            buf[x++] = hex[*p >> 4];
+            buf[x++] = hex[*p & 0x0f];
+        } else {
+            buf[x++] = *p;
+        }
+		if (x == len) {
+			break;
+		}
+    }
+	return x;
+}
+
+
+
+
+
 #endif
Index: include/asterisk/utils.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/utils.h,v
retrieving revision 1.40
diff -u -u -r1.40 utils.h
--- include/asterisk/utils.h	19 Jul 2005 23:17:02 -0000	1.40
+++ include/asterisk/utils.h	29 Jul 2005 18:55:38 -0000
@@ -155,5 +155,7 @@
 #define AST_STACKSIZE 256 * 1024
 #define ast_pthread_create(a,b,c,d) ast_pthread_create_stack(a,b,c,d,0)
 extern int ast_pthread_create_stack(pthread_t *thread, pthread_attr_t *attr, void *(*start_routine)(void *), void *data, size_t stacksize);
+extern int url_encode(char *uri, char *buf, size_t len);
+extern void url_decode(char *s);
 
 #endif /* _ASTERISK_UTILS_H */
